var addLunWindow_taht = window.top.UNAS.GetWindow('jv-addLunWindow');
var addLunWindow_options = addLunWindow_taht.options;

function fcsantarget_availdevices() {
  jQuery('#jv-mappinglunstotarget-page-loading').show();
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'fcsantarget_availdevices',
      token: UToken,
      params: {
        name: addLunWindow_options.data.name
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        jQuery('#jv-mappingluns-host').empty();
        var i = 0;
        for (var v in info) {
          if (info.hasOwnProperty(v)) {
            var lundom = fctargetTemplateAppend('#jv-mappingluns-host', 'jvt-lunitem-tr', 'jvt-lunitem-tr' + i);
            lundom.find('.lun_name').text(info[v].name);
            lundom.find('.lun_path').text(info[v].dev);
            lundom.find('.lun_size').text(UNAS.getReadableSizeString(info[v].size));
            lundom.find('input[type=checkbox]').attr('id', 'jv-checkLun-' + i);
            lundom.find('input[type=checkbox]').attr('name', 'checkLun');
            lundom.find('label').attr('for', 'jv-checkLun-' + i);
            lundom.find('input[type=checkbox]').data('luninfo', info[v]).on('click', function() {

              var len = jQuery('#jv-mappingluns-host input[type=checkbox]:checked').length;
              if (len) {
                jQuery("#fctarget_mappinglun_btn").attr("class", "unas_button_sub");
                jQuery("#fctarget_mappinglun_btn").attr("disabled", false);
              } else {
                jQuery("#fctarget_mappinglun_btn").attr("class", "unas_button_sub_disabled");
                jQuery("#fctarget_mappinglun_btn").attr("disabled", true);
              }
            })
          }

          i++;
        }
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      jQuery('#jv-mappinglunstotarget-page-loading').hide();
    }
  });
}

function submit_mappingLuns_fc() {
  var dev = [];

  jQuery('#jv-mappingluns-host input[type=checkbox]:checked').each(function(i, e){
    var luninfo = jQuery(e).data('luninfo');
    dev.push(luninfo.dev);
  })

  jQuery('#jv-mappinglunstotarget-page-loading').show();
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'fcsantarget_mount',
      token: UToken,
      params: {
        name: addLunWindow_options.data.name,
        devs: dev
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {
        MUI.closeWindow($('jv-addLunWindow'));
        fcsantarget_alload(0);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      jQuery('#jv-mappinglunstotarget-page-loading').hide();
    }
  });
}

(function() {
  fcsantarget_availdevices();
  jQuery('#jv-fcTargetName-lun').text(addLunWindow_options.data.name);

})();
