function fcsantarget_alload(sw) {
  jQuery('#jv-fctarget-page-loading').show();
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'fcsantarget_alload',
      token: UToken,
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {
        var info = res.results;
        if (jQuery.isEmptyObject(info)) {
          jQuery('#jv-fctarget-none').show();
          jQuery('#jv-fctarget-host').hide();
        } else {
          jQuery('#jv-fctarget-none').hide();
          jQuery('#jv-fctarget-host').show();
          jQuery('#jv-fctarget-host').empty();
          var i = 0;
          for (var v in info) {
            if (info.hasOwnProperty(v)) {
              var luns = info[v].backstores || {};
              var fctargetdom = fctargetTemplateAppend('#jv-fctarget-host', 'jvt-fctarget-item', 'jvt-fctarget-item' + i);
              fctargetdom.data('fctargetinfo', info[v]);
              fctargetdom.find('.jvc-fcTargetName').text(info[v].name);
              fctargetdom.find('.jvc-fcwwn').text(info[v].wwn);
              fctargetdom.find('.jvc-active').attr('class', 'jvc-active zt-' + info[v].active);
              fctargetdom.find('.jvc-active').text(info[v].active ? '(Ready)' : '(Offline)');

              fctargetdom.find('.jvc-active-img').attr('class', 'jvc-active-img img-state active-' + info[v].active);

              if (info[v].active) {
                fctargetdom.find('.jvc-opActive').text('Deactivate');
              } else {
                fctargetdom.find('.jvc-opActive').text('Activate');
              }
              if (jQuery.isEmptyObject(luns)) {
                fctargetdom.find('.jvc-delFctgtBtn').on('click', function() {
                  var fcinfo = jQuery(this).closest('dl.fctarget_box_cont').data('fctargetinfo');
                  delfctargetWF(fcinfo);
                })

                fctargetdom.find('.jvc-luns-host').html('<li class="lun-null">##$@fc@$##No LUN exists, please add LUN##$@fc@$##</li>');

              } else {
                fctargetdom.find('.jvc-delFctgtBtn').addClass('delbtndisabled');
                var j = 0;
                for (var k in luns) {
                  if (luns.hasOwnProperty(k)) {
                    var lunhost = fctargetdom.find('.jvc-luns-host');
                    var lundom = fctargetTemplateAppend(lunhost, 'jvt-lunitem', 'jvt-lunitem' + i + j);
                    lundom.find('.jvc-lunDev').text(luns[k].dev);
                    lundom.find('.jvc-lunName').text(luns[k].name);
                    lundom.find('.jvc-lunSize').text(UNAS.getReadableSizeString(luns[k].size));
                    lundom.find('.jvc-umount').data('luninfo', luns[k]);
                    lundom.find('.jvc-umount').on('click', function() {
                      var fcinfo = jQuery(this).closest('dl.fctarget_box_cont').data('fctargetinfo');
                      umountLunWF(fcinfo, jQuery(this).data('luninfo'));
                    })
                  }

                  j++;
                }
              }
              var scro_flag = 0;
              if (sw) {
                if (i == 0) {
                  scro_flag = 1;
                  FCPageData.isOpen[i] = 1;
                } else {
                  FCPageData.isOpen[i] = 0;
                }
              } else {
                scro_flag = FCPageData.isOpen[i];
              }

              if (scro_flag) {
                fctargetdom.find('.toggle-target').attr('class', 'toggle-target t-open');
                fctargetdom.find('.jvc-luns-host').addClass('open-lunsBox');
                fctargetdom.find('.box-dt').css('background', '#f3f3f3');
              }

              fctargetdom.find('.toggle-target').attr('index', i).on('click', function() {
                var node = jQuery(this).closest('dl.fctarget_box_cont');
                openCloseTargetLunList(node, +jQuery(this).attr('index'));
              });


              fctargetdom.find('.jvc-fcsantargetActiveBtn').attr('active', info[v].active).on('click', function() {
                var targetNode = jQuery(this).closest('dl.fctarget_box_cont');
                fcsantarget_active(targetNode);
              });

              fctargetdom.find('.jvc-viewtgtBtn').on('click', function() {
                var fcinfo = jQuery(this).closest('dl.fctarget_box_cont').data('fctargetinfo');
                viewfctargetWF(fcinfo);
              });
              fctargetdom.find('.jvc-edittgtBtn').on('click', function() {
                var fcinfo = jQuery(this).closest('dl.fctarget_box_cont').data('fctargetinfo');
                editfctargetWF(fcinfo);
              })

              fctargetdom.find('.jvc-addLunBtn').on('click', function() {
                var fcinfo = jQuery(this).closest('dl.fctarget_box_cont').data('fctargetinfo');
                addLunWF(fcinfo);
              })

            }


            i++;
          }

          jQuery("#jv-fctarget-host").mCustomScrollbar({
            autoHideScrollbar: true,
            theme: "minimal-dark"
          });
        }
      } else {
        jQuery('#jv-fctarget-none').show();
        jQuery('#jv-fctarget-host').hide();
      }

      TranslateFcTarget('jv-fctarget-host');
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      jQuery('#jv-fctarget-page-loading').hide();
    }
  });
}

//
function openCloseTargetLunList(node, i) {
  var t = node.find('.toggle-target');

  if (t.hasClass('t-close')) {
    t.addClass('t-open').removeClass('t-close');
    node.find('.jvc-luns-host').addClass('open-lunsBox');
    node.find('.box-dt').css('background', '#f3f3f3');
    FCPageData.isOpen[i] = 1;
  } else {
    t.addClass('t-close').removeClass('t-open');
    node.find('.jvc-luns-host').removeClass('open-lunsBox');
    node.find('.box-dt').css('background', '#f7f7f7');
    FCPageData.isOpen[i] = 0;
  }

}

//启用 || 停用
function fcsantarget_active(node) {
  var info = node.data('fctargetinfo');
  var active = +node.find('.jvc-fcsantargetActiveBtn').attr('active') ? 0 : 1;
  jQuery('#jv-fctarget-page-loading').show();
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'fcsantarget_active',
      token: UToken,
      params: {
        name: info.name,
        active: active
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {

      if (res.err == 0) {
        fcsantarget_alload(0);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      jQuery('#jv-fctarget-page-loading').hide();
    }
  });

}
//查看
function viewfctargetWF(data) {
  var viewfctargetWindow = new MUI.Modal({
    id: 'jv-viewfctargetWindow',
    title: UNAS._('View') +  'FC Target',
    modal: true,
    width: 750,
    height: 638,
    data: data,
    modalOverlayClose: false,
    contentURL: '/apps/fctarget/view_target.html?v=6.0.9&'
  });
}
//编辑
function editfctargetWF(data) {
  createFcTargetWF('Edit', data);
}

//添加 LUN 链接
function addLunWF(data) {
  var addLunWindow = new MUI.Modal({
    id: 'jv-addLunWindow',
    title: UNAS._('Mapping LUN'),
    modal: true,
    width: 750,
    height: 480,
    data: data,
    modalOverlayClose: false,
    contentURL: '/apps/fctarget/lun_mapping.html?v=6.0.9&'
  });
}
//删除
function delfctargetWF(data) {
  var delfctargetWindow = new MUI.Modal({
    id: 'jv-delfctargetWindow',
    title: UNAS._('Delete FC Target'),
    modal: false,
    width: 400,
    height: 200,
    data: data,
    modalOverlayClose: false,
    contentURL: '/apps/fctarget/delete_target.html?v=6.0.9&'
  });

}

//解除连接
function umountLunWF(fcinfo, luninfo) {
  var umountLunWindow = new MUI.Modal({
    id: 'jv-umountLunWindow',
    title: UNAS._('##$@fc@$##Umount Lun##$@fc@$##'),
    modal: true,
    width: 400,
    height: 200,
    fcinfo: fcinfo,
    luninfo: luninfo,
    modalOverlayClose: false,
    contentURL: '/apps/fctarget/umount_lun.html?v=6.0.9&'
  });
}

//创建FC
function createFcTargetWF(type = 'Create', data) {
  var createfctargetWindow = new MUI.Modal({
    id: 'jv-createfctargetWindow',
    title: UNAS._('##$@fc@$##' + type + '##$@fc@$##') + ' FC Target',
    modal: true,
    width: 750,
    height: 675,
    wfType: type,
    data: data,
    modalOverlayClose: false,
    contentURL: '/apps/fctarget/create_fctarget.html?v=6.0.9&'
  });
}

(function() {
  fcsantarget_alload(1);
})();
