var createfctargetWindow_taht = window.top.UNAS.GetWindow('jv-createfctargetWindow');
var createfctarget_options = createfctargetWindow_taht.options;

function fcsantarget_create() {
  var name = jQuery('#jv-fctargetName').val();
  var wwn = jQuery('#jv-fctargetWWN').text();
  var active = 1;
  var acls = {};

  if (jQuery('#jv-wwn-host tr').length) {
    jQuery('#jv-wwn-host tr').each(function(i, e) {
      var wwnName = jQuery(e).find('.jvc-wwnname').text().trim();
      acls[wwnName] = {};
    })
  }

  var cmd = createfctarget_options.wfType == 'Edit' ? 'fcsantarget_modify' : 'fcsantarget_create';

  jQuery('#jv-createfctarget-page-loading').show();
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: cmd,
      token: UToken,
      params: {
        name: name,
        wwn: wwn,
        active: active,
        acls: acls
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {
        MUI.closeWindow($('jv-createfctargetWindow'));
        var f = jQuery('#jv-fctarget-none').is(":visible") ? 1 : 0;
        fcsantarget_alload(f);

      } else {

      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      jQuery('#jv-createfctarget-page-loading').hide();
    }
  });
}

function addFiberPortWF() {
  var addFiberPortWindow = new MUI.Modal({
    id: 'jv-addFiberPortWindow',
    title: UNAS._('##$@fc@$##Add Optical Fiber Port##$@fc@$##'),
    modal: true,
    width: 410,
    height: 175,
    modalOverlayClose: false,
    contentURL: '/apps/fctarget/add_fiber_port.html?v=6.0.9&'
  });
}

function selectFiberPortWF() {
  var selectFiberPortWindow = new MUI.Modal({
    id: 'jv-selectFiberPortWindow',
    title: UNAS._('##$@fc@$##Select Optical Fiber Port##$@fc@$##'),
    modal: true,
    width: 1000,
    height: 475,
    modalOverlayClose: false,
    contentURL: '/apps/fctarget/select_fiber_port.html?v=6.0.9&'
  });
}

// 获取fc 信息
function fcsantarget_acquit(info) {
  jQuery('#jv-createfctarget-page-loading').show();
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'fcsantarget_acquit',
      token: UToken,
      params: {
        name: info.name
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {
        var info = res.results;
        var acls = info.acls || {};
        jQuery('#jv-fctargetName').val(info.name).attr('disabled', true);
        jQuery('#jv-fctargetWWN').text(info.wwn);
        jQuery('#jv-createtargetSubBtn').attr('class', 'unas_button_sub');
        jQuery('#jv-createtargetSubBtn').attr('disabled', false);
        jQuery('#jv-wwn-host').empty();
        var i = 0;
        for (var v in acls) {
          if (acls.hasOwnProperty(v)) {
            var wwndom = fctargetTemplateAppend('#jv-wwn-host', 'jvt-wwn-tr', 'jvt-wwn-tr' + i);
            wwndom.find('.jvc-wwnname').text(v);
            wwndom.find('.jvc-delwwn').on('click', function(){
              jQuery(this).parent().parent().remove();
              updateCreateTargetBtnState();
            })
          }
          i++;
        }

      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      jQuery('#jv-createfctarget-page-loading').hide();
    }
  });
}

function updateCreateTargetBtnState(){
  if (jQuery('#jv-fctargetName').val() && jQuery('#jv-fctargetWWN').text()) {
    jQuery('#jv-createtargetSubBtn').attr('class', 'unas_button_sub');
    jQuery('#jv-createtargetSubBtn').attr('disabled', false);
  } else {
    jQuery('#jv-createtargetSubBtn').attr('class', 'unas_button_sub_disabled');
    jQuery('#jv-createtargetSubBtn').attr('disabled', true);
  }
}

(function() {

  if (createfctarget_options.wfType == 'Edit') {
    jQuery('#jv-plimg').attr('src', "/apps/fctarget/images/edit_fc_logo?v=6.0.9&");
    var fcInfo = createfctarget_options.data;
    fcsantarget_acquit(fcInfo);
    jQuery('#jv-createtargetSubBtn').text(UNAS._('##$@fc@$##Enter##$@fc@$##'));
  }

  jQuery("#jv-fctargetName").bind('input porpertychange', function() {

    updateCreateTargetBtnState();
  });
})()
